// TimeTask.h
// Created by Bill Hubauer on Wed, Jul 26, 1995 @ 8:16 AM.

#ifndef __TimeTask__
#define __TimeTask__

#ifndef __TIMER__
#include <timer.h>
#endif
#include "ObjectQueue.h"

class MTimeTask : public MQueueElem
{

public:


	MTimeTask();
	virtual ~MTimeTask();
	
	void	SetIdleTime(UInt32	milliTime);
	void	StartTimer();
	
	virtual void	DoTask() = 0;		// must call StartTimer to get called again

			void	DisableTask()	{fEnabledQ = false;}

	Boolean		fPrimedQ;
	Boolean		fEnabledQ;
	
	static	void	KillAllTimeTasks();

protected:
	void	KillTask();
	
	struct ObjTask {
		TMTask		task;
		OSType		sig;
		MTimeTask*	obj;
		long		globals;
	};
	
	ObjTask		_tm;
	UInt32		_idleTime;
	Boolean		fInstalledQ;
	
	static CObjectQueue		sTimeTasks;

};

#endif
